var db = require('mongoose')
	, Entry = db.model('entry')
	;

var createRandomShortString = function() {
  var now = new Date();
  return Math.floor((Math.random()*1000000000) + now.getTime()).toString(36);
};

exports.create = function(req,res){
	try {
		var user = req.session.user;
		var slug = createRandomShortString();

		var entry = new Entry({owner: user._id, slug: slug, long_url: req.body.url});
		entry.save(function(err,entry){
			if (err) {
				res.send("An error occured: " + err.toString());
			}
			else if (!entry) {
				res.send("Unable to create entry.");
			}
			else {
				res.redirect('/entries/' + entry._id);
			}
		});
	}
	catch (ex) {
		res.send("An error occured: " + ex.toString());
	}
};

exports.index = function(req,res){
	res.render('entry/index');
};

exports.edit = function(req,res){
	res.render('entry/edit');	
};

exports.show = function(req,res){
	try {
		Entry.findOne({_id: req.params.entry}, function(err, entry){
			if (err) {
				res.send("An error occured: " + err.toString());
			}
			else if (!entry) {
				res.send("Could not get entry");
			}
			else {
				res.render('entry/show', {'entry': entry});
			}
		});
	}
	catch(ex) {
		res.send("An error occured: " + ex.toString());
	}
};

exports.new = function(req,res){
	res.render('entry/new');	
};

exports.update = function(req,res){
};

exports.destroy = function(req,res){
};

exports.redirect = function(req,res,next){
	Entry.findOne({slug: req.params.slug}, function(err,entry){
		if (err){
			res.redirect('/error');
		}
		else if (!entry){
			next();
		}
		else {
			res.redirect(entry.long_url);
		}
	});
};