var db = require('mongoose')
	, Resource = require('express-resource')
	, Entry = require('./entry')
	, User = require('./user')
	;

exports.index = function(req,res){
	res.render('index', {title: 'Clvr'});
};

exports.error = function(req,res){
	res.render('error', {title: 'Clvr'});
};

exports.authenticate = function(req, res, next) {
	if (!req.session.user) {
		res.redirect('/');
	}
	else {
		next();
	}
};

module.exports.define = function(app) {
	console.log("Defining routes");
	app.get('/', exports.index);
	app.get('/:slug', Entry.redirect);
	app.get('/error', exports.error);

	app.all('/entries*', exports.authenticate);

	app.resource('entries', Entry);
	app.resource('user', User);

	app.all('/user/edit', exports.authenticate);
	app.all('/user/update', exports.authenticate);
	app.all('/user/show', exports.authenticate);

	app.post('/login', User.login);
	app.get('/logout', User.logout);
};