var db = require('mongoose')
	, ObjectId = db.Types.ObjectId
	, User = db.model('user')
	, bcrypt = require('bcrypt')
	;

exports.login = function(req,res) {
	try {
		User.findOne({email: req.body.email}, function(err,user){
			if (err) {
				res.send("An error occured: " + err.toString());
			}
			else if (!user) {
				res.send("User not found.");
			}
			else {
				var pwdMatch = bcrypt.compareSync(req.body.password, user.password);
				if (pwdMatch) {
					req.session.user = user;
					res.redirect('/entries');
				}
				else {
					res.send("Passwords did not match.");
				}
			}
		});
	}
	catch (ex) {
		res.send("An error occured: " + ex.toString());
	}
};

exports.logout = function(req, res) {
	req.session.user = null;
	res.redirect('/');
};

exports.index = function(req,res){
	res.render('user/index');	
};

exports.show = function(req,res){	
	res.render('user/show');
};

exports.edit = function(req,res){	
	res.render('user/edit');
};

exports.update = function(req,res) {
};

exports.new = function(req,res){
	res.render('user/new');
};

exports.create = function(req,res) {
	try {
		User.findOne({email: req.body.email }, function(err,user){
			if (err) {
				res.send("An error occured: " + err.toString());
			}
			else if (user) {
				res.send("A user with that email already exists.");
			}
			else {
				var user = new User({email: req.body.email});
				user.password = bcrypt.hashSync(req.body.password, 8);

				user.save(function(err,user){
					if (err) {
						res.send("An error occured: " + err.toString());
					}
					else if (!user) {
						res.send("Unable to create user.");
					}
					else {
						req.session.user = user;
						res.redirect('/entries');
					}
				});
			}
		});
	}
	catch (ex){
		res.send("An error occured: " + ex.toString());
	}
};

exports.destroy = function(req,res){	
};